config/routes.rb
Salasrosario::Application.routes.draw do
  
  root :to => 'reservations#index' #RAILS 3

  resources :users,                only: [:index, :new, :create, :show, :edit, :update, :destroy]
  resources :musicians,            only: [:index, :new, :create, :show, :edit, :update]
  resources :bands,                only: [:index, :new, :create, :edit, :update]
  resources :rooms,                only: [:index, :edit, :update]
  resources :room_prices,          only: [:index, :new, :create, :show, :edit, :update, :destroy]
  resources :reservation_types,    only: [:index]
  resources :reservations,         only: [:index, :new, :create, :show, :edit, :update]
  resources :cancellations,        only: [:new, :create]

end

app/models/user.rb
class User < ActiveRecord::Base
  has_many :reservations
  has_many :cancellations
  attr_accessible :user_id, :dni, :login, :passwd, :lastname, :name, :role, :status
  validates :dni, :login, :passwd, :lastname, :name, :role, :status, :presence => true
  validates :dni, :login, :uniqueness => true

  def role_denomination
    case self.role
      when '3' then return 'Webmaster'
      when '2' then return 'Administrador'
      else return 'Encargado'
    end
  end

end

app/controllers/users_controller.rb
class UsersController < ApplicationController
  # GET /users
  # GET /users.json
  def index
    @users = User.all # FIXME
    # @users = User.where("status = 1")

    respond_to do |format|
      format.html # index.html.erb
      format.json { render json: @users }
    end
  end

  # GET /users/1
  # GET /users/1.json
  def show
    @user = User.find(params[:id])

    respond_to do |format|
      format.html # show.html.erb
      format.json { render json: @user }
    end
  end

  # GET /users/new
  # GET /users/new.json
  def new
    @user = User.new

    respond_to do |format|
      format.html # new.html.erb
      format.json { render json: @user }
    end
  end

  # GET /users/1/edit
  def edit
    @user = User.find(params[:id])
  end

  # POST /users
  # POST /users.json
  def create
    @user = User.new(params[:user])

    respond_to do |format|
      if @user.save
        format.html { redirect_to users_url, notice: "User #{@user.name} #{@user.lastname} was successfully created." }
        format.json { render json: @user, status: :created, location: @user }
      else
        format.html { render action: "new" }
        format.json { render json: @user.errors, status: :unprocessable_entity }
      end
    end
  end

  # PUT /users/1
  # PUT /users/1.json
  def update
    @user = User.find(params[:id])

    respond_to do |format|
      if @user.update_attributes(params[:user])
        format.html { redirect_to edit_user_path(@user), notice: 'User was successfully updated.' }
        format.json { head :no_content }
      else
        format.html { render action: "edit" }
        format.json { render json: @user.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /users/1
  # DELETE /users/1.json
  def destroy
    @user = User.find(params[:id])

    respond_to do |format|
      if @user.update_attributes(status: 0)
        format.html { redirect_to users_url, notice: "User #{@user.name} #{@user.lastname} was successfully destroyed." }
        format.json { head :no_content }
      else
        format.html { render action: "edit" }
        format.json { render json: @user.errors, status: :unprocessable_entity }
      end
    end
  end
end

app/helpers/users_helper.rb
module UsersHelper
end

app/views/users/_form.html.erb
<%= form_for @user, html: {class: "form-horizontal"} do |f| %>

  <% if @user.errors.any? %>
    <div class="alert alert-error">
      <button type="button" class="close" data-dismiss="alert">×</button>
      <h3><%= pluralize(@user.errors.count, "error") %> prohibited this user from being saved:</h3>
      <ul>
      <% @user.errors.full_messages.each do |msg| %>
        <li><%= msg %></li>
      <% end %>
      </ul>
    </div>
  <% end %>

  <% if notice %>
    <div class="alert alert-success">
      <button type="button" class="close" data-dismiss="alert">×</button>
      <p><%= notice %></p>
    </div>
  <% end %>

  <div class="control-group">
    <%= f.label :login, { class: 'control-label' } %>
    <div class="controls">
      <%= f.text_field :login %>
    </div>
  </div>
  <div class="control-group">
    <%= f.label :passwd, { class: 'control-label' } %>
    <div class="controls">
      <%= f.text_field :passwd %>
    </div>
  </div>
  <div class="control-group">
    <%= f.label :dni, { class: 'control-label' } %>
    <div class="controls">
      <%= f.text_field :dni %>
    </div>
  </div>
  <div class="control-group">
    <%= f.label :name, { class: 'control-label' } %>
    <div class="controls">
      <%= f.text_field :name %>
    </div>
  </div>
  <div class="control-group">
    <%= f.label :lastname, { class: 'control-label' } %>
    <div class="controls">
      <%= f.text_field :lastname %>
    </div>
  </div>
  <div class="control-group">
    <%= f.label :role, { class: 'control-label' } %>
    <div class="controls">
      <%= f.select(:role, options_for_select([['Encargado', '1'], ['Duenio', '2'], ['Webmaster', '3']], selected: @user.role)) %>
    </div>
  </div>
  <div class="control-group">
    <%= f.label :status, "Activado", { class: 'control-label' } %>
    <div class="controls">
      <%= f.check_box(:status) %>
    </div>
  </div>

  <div class="form-actions">
    <%= f.submit "Guardar", { class: 'btn btn-primary' } %>
    <%= link_to 'Atras', users_path, { class: 'btn' } %>
  </div>

<% end %>

app/views/users/edit.html.erb
<h1>Editar Usuario</h1>

<%= render 'form' %>

app/views/users/index.html.erb
<h1>Listado de Usuarios</h1>

<% if notice %>
  <div class="alert alert-success">
    <button type="button" class="close" data-dismiss="alert">×</button>
    <p><%= notice %></p>
  </div>
<% end %>

<table class="table table-hover table-condensed table-striped table-bordered">
  <tr>
    <th>Login</th>
    <th>Dni</th>
    <th>Name</th>
    <th>Lastname</th>
    <th>Role</th>
    <th></th>
    <th></th>
  </tr>

<% @users.each do |user| %>
  <tr>
    <td><%= user.login %></td>
    <td><%= user.dni %></td>
    <td><%= user.name %></td>
    <td><%= user.lastname %></td>
    <td><%= user.role_denomination %></td>
    <td><%= link_to 'Edit', edit_user_path(user) %></td>
    <td><%= link_to 'Destroy', user, method: :delete, data: { confirm: 'Are you sure?' } %></td>
  </tr>
<% end %>
</table>

<%= link_to 'Nuevo Usuario', new_user_path, { class: 'btn btn-primary' } %>

app/views/users/new.html.erb
<h1>Nuevo Usuario</h1>

<%= render 'form' %>

app/views/users/show.html.erb
<p id="notice"><%= notice %></p>

<p>
  <b>Login:</b>
  <%= @user.login %>
</p>

<p>
  <b>Dni:</b>
  <%= @user.dni %>
</p>

<p>
  <b>Name:</b>
  <%= @user.name %>
</p>

<p>
  <b>Lastname:</b>
  <%= @user.lastname %>
</p>

<p>
  <b>Role:</b>
  <%= @user.role %>
</p>

<p>
  <b>Status:</b>
  <%= @user.status %>
</p>


<%= link_to 'Editar', edit_user_path(@user) %> |
<%= link_to 'Atras', users_path %>